//Fahrzeug an einer Stelle x,y in einem Winkel phi zeigen:

//Koordinatentransformation
function vek = tr(P,x,y,phi)
    T = [cos(phi),-sin(phi);sin(phi),cos(phi)];
    vek = [x;y]+T*P;
endfunction

//Nur Drehung
function vek = dr(P,phi)
    T = [cos(phi),-sin(phi);sin(phi),cos(phi)];
    vek = T*P;
endfunction

//Kreuzprodukt, liefert 3. komponente als Skalar
function w = kr(P,Q)
    w = P(1)*Q(2)-P(2)*Q(1);
endfunction

//Kreuzprodukt speziell um v aus omega zu bestimmen
function v = kv(w,P)
    v = [-w*P(2);w*P(1)];
endfunction

function zeigeFahrzeug(x,y,phi)
    fahrzeug1 = [tr(PS,x,y,phi),tr(PS+[0.1;0],x,y,phi)];
    fahrzeug2 = [tr(PA,x,y,phi),tr(PB,x,y,phi),tr(PC,x,y,phi),tr(PD,x,y,phi),tr(PA,x,y,phi)];
    fahrzeug3 = [tr(PE,x,y,phi),tr(PF,x,y,phi),tr(PG,x,y,phi),tr(PH,x,y,phi),tr(PE,x,y,phi)];
    plot(fahrzeug1(1,:),fahrzeug1(2,:),fahrzeug2(1,:),fahrzeug2(2,:),fahrzeug3(1,:),fahrzeug3(2,:));
endfunction

function zeigeTisch()

    r = 0.85/2;
    p = 0:0.01:2.0*%pi;
    x = r*cos(p);
    y = r*sin(p);

    plot(x,y);
endfunction

function zeigeRahmen()

    plot([0.5,0.5,-0.5,-0.5,0.5],[-0.5,0.5,0.5,-0.5,-0.5]);
endfunction