clear();

PWMFAKTOR = 0.0245147; 
DAMP      = 29.469469;

//Masse des Fahrzeugs:
m = 0.871; //kg


h = 4*DAMP/m; 
k = (2*PWMFAKTOR)/m;

A = [ 0   1
      0   -h];

B = [0
     k];

spec(A)

r1=1;
r2=1;

R=[r1 r2];

R = ppol(A,B,[-2000+1000*%i,-2000-1000*%i]);
r1 = R(1);
r2 = R(2);

Astern = A-B*R;

spec(Astern)

vsoll = 0.2;

//Zustands-geregelt
function f = rechteSeiteZ(t,y)
    x  = y(1,1);
    v  = y(2,1);
    ie = y(3,1);    //Integral der Regeldifferenz
     e = vsoll - v; //Regeldifferenz

    pwm = r1*ie + r2*e + (h/k)*vsoll;

    f(1,1) = v;
    f(2,1) = -h*v + k*pwm;
    f(3,1) = e;  //Ableitung == Regeldifferenz
endfunction

//Vergleich: ohne Regler mit passendem pwm-Signal:
function f = rechteSeite(t,y)
    pwm = 481;
    x  = y(1,1);
    v  = y(2,1);
    f(1,1) = v;
    f(2,1) = -h*v+k*pwm;
endfunction


t=0:0.002:0.4;
y0=[0 0 0]';
t0=0;

y  = ode(y0,t0,t,rechteSeiteZ);   

y0=[0 0]';
t0=0;

ys  = ode(y0,t0,t,rechteSeite);   

plot(t,y(2,:));
plot(t,ys(2,:),'red--');




