//Nur Drehung
//function vek = dr(P,phi)
//    T = [cos(phi),-sin(phi);sin(phi),cos(phi)];
//    vek = T*P;
//endfunction

public double[] dr(double[] P, double phi)
{
      double[] vek = new double[2];
      
      vek[0] = Math.cos(phi)*P[0] - Math.sin(phi)*P[1];
      vek[1] = Math.sin(phi)*P[0] + Math.cos(phi)*P[1];
      
      return vek;
}

//Koordinatentransformation
//function vek = tr(P,x,y,phi)
//    T = [cos(phi),-sin(phi);sin(phi),cos(phi)];
//    vek = [x;y]+T*P;
//endfunction

public double[] tr(double[] P,double x, double y, double phi)
{
      double[] v = new double[2];
      
      v[0] = x + Math.cos(phi)*P[0]-Math.sin(phi)*P[1]; 
      v[1] = y + Math.sin(phi)*P[0]+Math.cos(phi)*P[1]; 
      
      return v;
}

public float[] trans(double[] P,double x, double y, double phi)
{
      float[] v = new float[2];
      
      v[0] = (float)(x + Math.cos(phi)*P[0]-Math.sin(phi)*P[1]); 
      v[1] = (float)(y + Math.sin(phi)*P[0]+Math.cos(phi)*P[1]); 
      
      v[1] = -v[1];
      
      v[0]*=SKAL;
      v[1]*=SKAL;
      
      v[0]+=displayWidth/2.0f;
      v[1]+=displayHeight/2.0f;
      
      return v;
}


//Kreuzprodukt speziell um v aus omega zu bestimmen
//function v = kv(w,P)
//    v = [-w*P(2);w*P(1)];
//endfunction

public double[] kv(double w, double[] P)
{
      double[] v = new double[2];
      
      v[0] = -w*P[1];
      v[1] =  w*P[0];
      
      return v;
}

public double[] summe(double[] va, double[] vb)
{
     double[] v = new double[2];
     
     v[0] = va[0] + vb[0];
     v[1] = va[1] + vb[1];
     
     return v;
}

public double[] summe(double[] va, double[] vb, double[] vc)
{
     double[] v = new double[2];
     
     v[0] = va[0] + vb[0] + vc[0];
     v[1] = va[1] + vb[1] + vc[1];
     
     return v;
}

public double betrag(double[] v)
{
      return Math.sqrt(v[0]*v[0]+v[1]*v[1]);
}

//Richtungsvektor, aber in negative Richtung
public double[] negricht(double[] va)
{
      double[] v = new double[2];
      double btr = betrag(va);
      
      v[0] = -va[0]/btr;
      v[1] = -va[1]/btr;
      
      return v;
}

public double[] skalmult(double s, double[] va)
{
     double[] v = new double[2];
     
     v[0] = s*va[0];
     v[1] = s*va[1];
     
     return v;      
}

public double skalarprodukt(double[] va, double[] vb)
{     
     return va[0]*vb[0]+va[1]*vb[1];      
}

//Kreuzprodukt, liefert 3. komponente als Skalar
//function w = kr(P,Q)
//    w = P(1)*Q(2)-P(2)*Q(1);
//endfunction

public double kr(double[] P, double[] Q)
{
    return P[0]*Q[1] - P[1]*Q[0];
}
